# Data Flow Facilitator for Machine Learning (dffml)

[![Actions Status](https://github.com/intel/dffml/workflows/Tests/badge.svg?branch=master&event=push)](https://github.com/intel/dffml/actions)
[![Gitpod Ready-to-Code](https://img.shields.io/badge/Gitpod-ready--to--code-blue?logo=gitpod)](https://gitpod.io/#https://github.com/intel/dffml)
[![codecov](https://codecov.io/gh/intel/dffml/branch/master/graph/badge.svg)](https://codecov.io/gh/intel/dffml)
[![CII](https://bestpractices.coreinfrastructure.org/projects/2594/badge)](https://bestpractices.coreinfrastructure.org/projects/2594)
[![Gitter chat](https://badges.gitter.im/gitterHQ/gitter.svg)](https://gitter.im/dffml/community)
[![PyPI version](https://img.shields.io/pypi/v/dffml.svg)](https://pypi.org/project/dffml)

## Mission Statement

DFFML aims to be the easiest and most convenient way to use Machine Learning.

- Its a machine learning distribution. Providing you access to a set of popular
  machine learning libraries guaranteed to work together.

- Its a AI/ML Python library, command line application, and HTTP service.

- You give it your data and tell it what kind of model you want to train. It
  creates a model for you.

- If you want finer grained control over the model, you can easily do so by
  implementing your own model plugin.

- We make it easy to use and deploy your models.

- We provide a directed graph concurrent execution environment with managed
  locking which we call DataFlows.

- DataFlows make it easy to generate datasets or modify existing datasets for
  rapid iteration on feature engineering.

## Documentation

Documentation for the latest release is hosted at https://intel.github.io/dffml/

Documentation for the master branch is hosted at
https://intel.github.io/dffml/master/index.html

## Contributing

The [contributing page](https://intel.github.io/dffml/master/contributing/index.html)
will guide you through getting setup and contributing to DFFML.

## Help

- Ask a question via an [issue](https://github.com/intel/dffml/issues/new?assignees=&labels=question&template=question.md&title=question%3A+)
- Send an email to dffml-users@lists.01.org
  - You can subscribe to the users mailing list here
    https://lists.01.org/postorius/lists/dffml-users.lists.01.org/
- Ask a question on the [Gitter chat](https://gitter.im/dffml/community)

## License

DFFML is distributed under the [MIT License](LICENSE).

## Legal

> This software is subject to the U.S. Export Administration Regulations and
> other U.S. law, and may not be exported or re-exported to certain countries
> (Cuba, Iran, Crimea Region of Ukraine, North Korea, Sudan, and Syria) or to
> persons or entities prohibited from receiving U.S. exports (including
> Denied Parties, Specially Designated Nationals, and entities on the Bureau
> of Export Administration Entity List or involved with missile technology or
> nuclear, chemical or biological weapons).
